#include <bits/stdc++.h> // all C/C++ libs
using namespace std;

int N, M;

struct Edge {
	int a,b,c;
	Edge *rev;
};

vector<Edge *> A[100000];
Edge * parent[100000];

void addEdge(int a, int b, int c) {
	Edge *e = new Edge{a,b,c}, *re = new Edge{b,a,0};
	e->rev = re;
	re->rev = e;
	A[a].push_back(e);
	A[b].push_back(re);
}

int bfs(int s, int t) {
	for(int i=0;i<N;i++) parent[i] = NULL;
	deque<int> Q;
	Q.push_back(s);
	while(!Q.empty()) {
		int a = Q.front();
		Q.pop_front();
		for(auto e: A[a]) {
			if(e->b == s || parent[e->b] || e->c == 0) continue;
			Q.push_back(e->b);
			parent[e->b] = e;
			if(e->b == t) return 1;
		}
	}
	return 0;
}

long long flow(int s, int t) {
	long long total = 0;
	while(bfs(s,t)) { //While there is a path P
		int a, b = t;
		unsigned int c, f = -1; //Find bottleneck capacity f in P
		while(b != s) {
			f = min((unsigned int)parent[b]->c,f);
			b = parent[b]->a;
		}
		
		total += f;
		
		b = t;
		while(b != s) { //Update the residual edges in P
			parent[b]->c -= f;
			parent[b]->rev->c += f;
			b = parent[b]->a;
		}
	}
	return total;
}

int main() {
	cin>>N>>M;
	for(int i=0;i<M;i++) {
		int a,b,c;
		cin>>a>>b>>c;
		addEdge(a-1,b-1,c);
	}
	cout<<flow(0,N-1)<<endl;
	return 0;
}